From ae9bb03b0f35c76bf71bdf0a4d181d48e81278eb Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:40:40 +0000
Subject: [PATCH 868/1001] Use the Feed component for the Streams page


---

diff --git a/hubs/static/client/app/core/Hubs.js b/hubs/static/client/app/core/Hubs.js
index 87768e9..fa53ab5 100644
--- a/hubs/static/client/app/core/Hubs.js
+++ b/hubs/static/client/app/core/Hubs.js
@@ -1,3 +1,4 @@
 import HubConfig from './HubConfig.jsx';
+import Streams from './Streams.jsx';
 
-module.exports = {HubConfig}
+module.exports = {HubConfig, Streams}
diff --git a/hubs/static/client/app/core/Streams.jsx b/hubs/static/client/app/core/Streams.jsx
new file mode 100644
index 0000000..fa257f9
--- /dev/null
+++ b/hubs/static/client/app/core/Streams.jsx
@@ -0,0 +1,189 @@
+import React from 'react';
+import {
+  IntlProvider,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import TabSet from '../components/TabSet.jsx';
+import ItemsGetter from '../components/feed/ItemsGetter.jsx';
+import Feed from '../components/feed/Feed.jsx';
+
+
+export default class Streams extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      items: {
+        "notif": [],
+        "action": [],
+      },
+      sseActive: false,
+    };
+    this.handleInitialData = this.handleInitialData.bind(this);
+    this.handleMessage = this.handleMessage.bind(this);
+    this.handleSave = this.handleSave.bind(this);
+    this.handleUnsave = this.handleUnsave.bind(this);
+  }
+
+  handleInitialData(data) {
+    var newItems = {
+        notif: data.notif,
+        action: data.action,
+      };
+    // Only activate SSE after the initial loading, or new elements may
+    // be overwritten.
+    this.setState({
+      items: newItems,
+      sseActive: true,
+    });
+  }
+
+  handleMessage(msg) {
+    var items = this.state.items[msg.type];
+    if (items.length >= this.props.messageLimit) {
+      items.pop();
+    }
+    items.unshift(msg);
+    this.setState((prevState, props) => {
+      prevState.items[msg.type] = items;
+      return {items: prevState.items};
+    });
+  }
+
+  handleSave(item) {
+    if (!this.props.urls.save) { return; }
+    const payload = {
+      link: item.link,
+      markup: item.markup,
+      secondary_icon: item.secondary_icon,
+      dom_id: item.dom_id,
+    };
+    $.ajax({
+      type: 'POST',
+      url: this.props.urls.save,
+      data: JSON.stringify(payload),
+      contentType: 'application/json',
+      success: () => {
+        this.setState((prevState, props) => {
+          var items = prevState.items.notif.map((currentItem) => {
+            if (currentItem.dom_id === item.dom_id) {
+              currentItem.saved = true;
+            }
+            return currentItem;
+          })
+          prevState.items.notif = items;
+          return {items: prevState.items};
+        });
+      },
+    });
+  }
+
+  handleUnsave(item) {
+    if (!this.props.urls.save) { return; }
+    var updateItemState = (item) => {
+      this.setState((prevState, props) => {
+        var items = prevState.items.notif.map((currentItem) => {
+          if (currentItem.dom_id === item.dom_id) {
+            currentItem.saved = false;
+          }
+          return currentItem;
+        });
+        prevState.items.notif = items;
+        return {items: prevState.items};
+      });
+    };
+    if (item.idx) {
+      // Already saved
+      $.ajax({
+        type: 'DELETE',
+        url: `${this.props.urls.save}${item.idx}/`,
+        success: () => { updateItemState(item) },
+      });
+    } else {
+      updateItemState(item);
+    }
+  }
+
+  render() {
+    var saved = [];
+    if (this.state.items.notif) {
+      saved = this.state.items.notif.filter((item) => (item.saved));
+    }
+
+    return (
+      <IntlProvider locale={navigator.language}>
+        <ItemsGetter
+          sseActive={this.state.sseActive}
+          urls={this.props.urls}
+          handleMessage={this.handleMessage}
+          handleInitialData={this.handleInitialData}
+          >
+          <TabSet tabListClass="mb-3">
+            <FeedPanel
+              hub={this.props.hub}
+              tabTitle="My Stream"
+              >
+              <Feed
+                items={this.state.items.notif}
+                handleSave={this.handleSave}
+                handleUnsave={this.handleUnsave}
+                />
+            </FeedPanel>
+            <FeedPanel
+              hub={this.props.hub}
+              tabTitle="My Actions"
+              >
+              <Feed
+                items={this.state.items.action}
+                handleSave={this.handleSave}
+                handleUnsave={this.handleUnsave}
+                />
+            </FeedPanel>
+            <FeedPanel
+              hub={this.props.hub}
+              tabTitle="Saved Notifications"
+              >
+              <Feed
+                items={saved}
+                handleSave={this.handleSave}
+                handleUnsave={this.handleUnsave}
+                />
+            </FeedPanel>
+          </TabSet>
+        </ItemsGetter>
+      </IntlProvider>
+    );
+  }
+}
+
+
+class FeedPanel extends React.Component {
+
+  render() {
+    const filters_url = `https://apps.fedoraproject.org/notifications/${this.props.hub}.id.fedoraproject.org/`;
+
+    return (
+      <div>
+        <div className="input-group">
+          <input
+            type="search" className="form-control"
+            placeholder="Search this activity stream..."
+            aria-describedby="searchform-addon" />
+          <span className="input-group-addon">
+            <span><i className="fa fa-search" aria-hidden="true"></i></span>
+          </span>
+        </div>
+        <br/>
+        <div className="alert alert-warning" role="alert">
+          This stream is filtered. <a href={filters_url} target="_blank">View Filters</a>
+        </div>
+        {this.props.children}
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 0397b69..0a15cac 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -33,15 +33,27 @@ def stream(name):
     )
 
 
-@app.route('/<user>/notifications', methods=['GET', 'POST'])
-@app.route('/<user>/notifications/', methods=['GET', 'POST'])
+@app.route('/<name>/stream/existing')
+@require_hub_access("view")
+def stream_existing(name):
+    hub = get_hub(name)
+    stream = hubs.stream.Stream()
+    existing = json.loads(stream.get_json())
+    saved = [s.dom_id for s in
+             hubs.models.SavedNotification.by_username(name)]
+    for e in existing:
+        e["saved"] = (e["dom_id"] in saved)
+    # Right now, stream and actions are the same.
+    # Once mentions is implemented, then each will be its own.
+    return flask.jsonify(dict(
+        status="OK", data=dict(notif=existing, action=existing),
+        ))
+
+
+@app.route('/<user>/notifications', methods=['POST'])
+@app.route('/<user>/notifications/', methods=['POST'])
 @login_required
 def notifications(user):
-    if flask.request.method == 'GET':
-        notifications = hubs.models.SavedNotification.by_username(user)
-        notifications = [n.__json__() for n in notifications]
-        return flask.jsonify(dict(notifications=notifications))
-
     if flask.request.method == 'POST':
         data = flask.request.get_json()
         user = hubs.models.User.by_username(user)
@@ -63,9 +75,9 @@ def notifications(user):
         )
         flask.g.db.add(notification)
         flask.g.db.commit()
-        return flask.jsonify(
-            dict(notification=notification.__json__(), success=True)
-        )
+        return flask.jsonify(dict(
+            status="OK", data=notification.__json__(),
+            ))
 
 
 @app.route('/<user>/notifications/<int:idx>', methods=['DELETE'])
@@ -78,7 +90,7 @@ def delete_notifications(user, idx):
         return flask.abort(400)
     flask.g.db.delete(notification)
     flask.g.db.commit()
-    return flask.jsonify(dict(status_code=200))
+    return flask.jsonify(dict(status="OK"))
 
 
 @app.route('/visit/<visited_hub>/', methods=['GET', 'POST'])

